/*
 * @(#)auth.c	1.10 Aug.3,1993
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * (C) yamasita@omronsoft.co.jp
 */

/*
 * This software is Copyright 1991 by Stan Barber. 
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction or this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * The author make no claims as to the fitness or correctness of this software
 * for any use whatsoever, and it is provided as is. Any use of this software
 * is at the user's own risk. 
 *
 */

#ifdef	MSDOS
#ifdef	PCNFS
#include "pcnfs.h"
#endif
#include <stdio.h>
#include <sys/types.h>
#include <ctype.h>
#ifdef INETBIOS
#include	<stdlib.h>
#include	"inetbios.h"
#elif PATHWAY
#ifdef INTERNAL
#include <socket/types.h>
#include <socket/fcntl.h>
#include <socket/socket.h>
#include <socket/time.h>
#include <socket/in.h>
#include <socket/errno.h>
#include <socket/netdb.h>
#else
#include <sys/types.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <sys/errno.h>
#include <netdb.h>
#endif
#else /* !INETBIOS !PATHWAY */
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#endif /* !INETBIOS */

#ifdef USG
# define	index	strchr
# define        bcopy(a,b,c)   memcpy(b,a,c)
# define        bzero(a,b)     memset(a,'\0',b)
#endif /* USG */

#include	"nntp.h"
#include	"gn.h"

#if	defined( INETBIOS ) || defined( PATHWAY )
int	pser_rd_fp;
int	pser_wr_fp;
#elif defined(PCNFS)
FILE	*pser_rd_fp;
FILE	*pser_wr_fp;
#else
extern FILE	*pser_rd_fp;
extern FILE	*pser_wr_fp;
#endif

#ifdef	AUTH_POP2
#define	POP	"pop"
#else
#define	POP	"pop3"
#endif

static auth_server_init(),auth_get_tcp_socket(),auth_get_server();
static void auth_put_server(),auth_close_server();

/*
 * auth_server_init  Get a connection to the remote ftp/pop server.
 *
 *	Parameters:	"machine" is the machine to connect to.
 *
 *	Returns:	-1 on error
 *			0 on success.
 *
 *	Side effects:	Connects to server.
 *			"pser_rd_fp" and "pser_wr_fp" are fp's
 *			for reading and writing to server.
 */
static
auth_server_init(machine)
char	*machine;
{
	int	sockt_rd, sockt_wr;
	char	line[256];

	sockt_rd = auth_get_tcp_socket(machine);

	if (sockt_rd < 0)
		return (-1);

	/*
	 * Now we'll make file pointers (i.e., buffered I/O) out of
	 * the socket file descriptor.  Note that we can't just
	 * open a fp for reading and writing -- we have to open
	 * up two separate fp's, one for reading, one for writing.
	 */

#if	defined( INETBIOS ) || defined( PATHWAY )
	pser_rd_fp = pser_wr_fp = sockt_rd;
#else
	if ((pser_rd_fp = fdopen(sockt_rd, "r")) == NULL) {
		perror("server_init: fdopen #1");
		return (-1);
	}

	sockt_wr = dup(sockt_rd);
	if ((pser_wr_fp = fdopen(sockt_wr, "w")) == NULL) {
		perror("server_init: fdopen #2");
		pser_rd_fp = NULL;		/* from above */
		return (-1);
	}
#endif /* INETBIOS */

	/* Now get the server's signon message */

	(void) auth_get_server(line, sizeof(line));
#ifdef	AUTH_FTP
	return (atoi(line));
#else
	if (line[0] == '+')
		return(0);
	else
		return(-1);
#endif
}


/*
 * auth_get_tcp_socket -- get us a socket connected to the ftp/pop server.
 *
 *	Parameters:	"machine" is the machine the server is running on.
 *
 *	Returns:	Socket connected to the news server if
 *			all is ok, else -1 on error.
 *
 *	Side effects:	Connects to server.
 *
 *	Errors:		Printed via perror.
 */
static
auth_get_tcp_socket(machine)
char	*machine;	/* remote host */
{
	int	s;
	struct	sockaddr_in sin;
	struct	servent *getservbyname(), *sp;
	struct	hostent *gethostbyname(), *hp;
	unsigned long inet_addr();
	static struct hostent def;
	static struct in_addr defaddr;
	static char namebuf[ 256 ];

#ifdef	AUTH_FTP
	if ((sp = getservbyname("ftp", "tcp")) ==  NULL) {
		fprintf(stderr, "ftp/tcp: Unknown service.\n");
		return (-1);
	}
#else
	if ((sp = getservbyname(POP, "tcp")) ==  NULL) {
		fprintf(stderr, "%s/tcp: Unknown service.\n",POP);
		return (-1);
	}
#endif
	/* If not a raw ip address, try nameserver */
	if (!isdigit(*machine) ||
	    (long)(defaddr.s_addr = inet_addr(machine)) == -1)
		hp = gethostbyname(machine);
	else {
		/* Raw ip address, fake  */
		(void) strcpy(namebuf, machine);
		def.h_name = namebuf;
#ifdef INETBIOS
		def.h_addr = defaddr.s_addr;
#else
		def.h_addr = (char *)&defaddr;
#endif
		def.h_length = sizeof(struct in_addr);
		def.h_addrtype = AF_INET;
		def.h_aliases = 0;
		hp = &def;
	}
	if (hp == NULL) {
		fprintf(stderr, "%s: Unknown host.\n", machine);
		return (-1);
	}

	bzero((char *) &sin, sizeof(sin));
	sin.sin_family = hp->h_addrtype;
#ifdef INETBIOS
	sin.sin_port = htons( sp->s_port );
#else
	sin.sin_port = sp->s_port;
#endif

	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("socket");
		return (-1);
	}

	/* And then connect */

#ifdef INETBIOS
	sin.sin_addr.s_addr = hp->h_addr;
#else
	bcopy(hp->h_addr, (char *) &sin.sin_addr, hp->h_length);
#endif
	if (connect(s, (struct sockaddr *) &sin, sizeof(sin)) < 0) {
		perror("connect");
		(void) close(s);
		return (-1);
	}

	return (s);
}


/*
 * auth_put_server -- send a line of text to the server, terminating it
 * with CR and LF, as per ARPA standard.
 *
 *	Parameters:	"string" is the string to be sent to the
 *			server.
 *
 *	Returns:	Nothing.
 *
 *	Side effects:	Talks to the server.
 *
 *	Note:		This routine flushes the buffer each time
 *			it is called.  For large transmissions
 *			(i.e., posting news) don't use it.  Instead,
 *			do the fprintf's yourself, and then a final
 *			fflush.
 */

static void
auth_put_server(string)
char *string;
{
#if	defined( INETBIOS ) || defined( PATHWAY )
  	char	cp[128];
#endif
#ifdef DEBUG
	fprintf(stderr, ">>> %s\n", string);
#endif
#if	defined( INETBIOS ) || defined( PATHWAY )
	strcpy( cp, string );
	strcat( cp, "\r\n" );
	send( pser_wr_fp, cp, strlen( cp ), 0 );
#else
	fprintf(pser_wr_fp, "%s\r\n", string);
	(void) fflush(pser_wr_fp);
#endif
}


/*
 * auth_get_server -- get a line of text from the server.  Strips
 * CR's and LF's.
 *
 *	Parameters:	"string" has the buffer space for the
 *			line received.
 *			"size" is the size of the buffer.
 *
 *	Returns:	-1 on error, 0 otherwise.
 *
 *	Side effects:	Talks to server, changes contents of "string".
 */
static
auth_get_server(string, size)
char	*string;
int	size;
{
	register char *cp;
	char	*index();

#if	defined( INETBIOS ) || defined( PATHWAY )
	int	ret;
	if ( ( ret = recvs( pser_rd_fp, string, size, 0 ) ) < 0 ) {
		printf( "Return code %d\n", ret );
		return (-1);
	}
#else
	if (fgets(string, size, pser_rd_fp) == NULL)
		return (-1);
#endif

	if ((cp = index(string, '\r')) != NULL)
		*cp = '\0';
	else if ((cp = index(string, '\n')) != NULL)
		*cp = '\0';
#ifdef DEBUG
	fprintf(stderr, "<<< %s\n", string);
#endif

	return (0);
}


/*
 * auth_close_server -- close the connection to the server, after sending
 *		the "quit" command.
 *
 *	Parameters:	None.
 *
 *	Returns:	Nothing.
 *
 *	Side effects:	Closes the connection with the server.
 *			You can't use "put_server" or "get_server"
 *			after this routine is called.
 */

static void
auth_close_server()
{
	char	pser_line[256];

#ifndef	PATHWAY
#ifdef INETBIOS
	if (pser_wr_fp == 0 || pser_rd_fp == 0 )
#else
	if (pser_wr_fp == NULL || pser_rd_fp == NULL)
#endif
		return;
#endif	/* PATHWAY */

	auth_put_server("QUIT");
	(void) auth_get_server(pser_line, sizeof(pser_line));

#if	defined( INETBIOS ) || defined( PATHWAY )
#ifdef	DEBUG
	printf("soclose %d\n",soclose( pser_rd_fp ));
#else
	soclose( pser_rd_fp );
#endif
#else
	(void) fclose(pser_wr_fp);
	(void) fclose(pser_rd_fp);
#endif
}

#define	LEN	1024
auth(usr)
unsigned char *usr;
{
	unsigned char resp[LEN];
	unsigned char pass[LEN];
	unsigned char *pt;
	int	retval = 0;

	sprintf(resp,"桼 %s ΥѥɤϤƲ",usrname);
	mc_puts(resp);
	fflush(stdout);
	pt = pass;
	*pt = 0;
	while (1) {
		*pt = getch();
		if ( *pt == '\n' || *pt == '\r' )
			break;
		pt++;
	}
	*pt = 0;
	printf("\n");

	mc_puts("ѥɤȹ礷Ƥޤ\n");

#ifdef	AUTH_FTP
	if ( auth_server_init(smtpserver) != 220 ) {
		mc_puts("ftp Ф³ǤޤǤ\n");
#else
	if ( auth_server_init(smtpserver) != 0 ) {
#ifdef	AUTH_POP2
		mc_puts("pop Ф³ǤޤǤ\n");
#else
		mc_puts("pop3 Ф³ǤޤǤ\n");
#endif
#endif
		return(-1);
	}

	sprintf(resp,"user %s",usr);
	auth_put_server(resp);
	auth_get_server(resp,LEN);
#ifdef	AUTH_FTP
	if ( atoi(resp) != 331 ) {
#else
	if ( resp[0] != '+' ) {
#endif
		mc_puts("桼Ĥޤ\n");	/* ??? */
		retval = -1;
	} else {
		sprintf(resp,"pass %s",pass);
		auth_put_server(resp);
		auth_get_server(resp,LEN);
#ifdef	AUTH_FTP
		if ( atoi(resp) != 230 ) {
#else
		if ( resp[0] != '+' ) {
#endif
			mc_puts("ѥɤ㤤ޤ\n");
			retval = -1;
		}
	}

	auth_close_server();
	return(retval);
}
#endif
